<?php

/**
 * -------------------------------------
 * @Author      Reza Moghaddam
 * @URL         moghaddam24.ir
 * @Email       r324.moghaddam@gmail.com
 * @Tel         09156990565
 * -------------------------------------
 */

class Store
{
    public static $LastRequest;
    
    public static function getPlugins($cat, $from, $to, $name){
        $str = file_get_contents("http://www.tdatalife.com/store/?do={$cat}&from={$from}&to={$to}&name={$name}");
    	if(strlen($str)>0){
    		preg_match("/(.*)/",$str,$data);
    		return $data[1];
    	}
    }
}

class Plugin
{
    public static $dir_list; 
    public static $files_list;
    
    function PluginList() {
        	$self->dir_list = array ();
        	
        	$handle = opendir( './plugins' );
        	
        	while ( false !== ($file = readdir( $handle )) ) {
        		if( is_dir( "./plugins/$file" ) and ($file != "." and $file != "..") ) {
        			$self->dir_list[] = $file;
        		}
        	}
        	closedir( $handle );
        	
        	return $self->dir_list;
    }
    
    function DirList($PluginName) {
        	$self->dir_list = array ();
        	
        	$handle = opendir( "./plugins/$PluginName" );
        	
        	while ( false !== ($file = readdir( $handle )) ) {
        		if( is_dir( "./plugins/$PluginName/$file" ) and ($file != "." and $file != "..") ) {
        			$self->dir_list[] = $file;
        		}
        	}
        	closedir( $handle );
        	
        	return $self->dir_list;
    }

    function tpl_on_plugins($list){
        $self->files_list = array ();
        foreach ($list as $item) {
        $dir = @ dir('plugins/' . $item . '/templates');
        
        while (($file = $dir->read()) !== false)
            {
            	$tmpArFileFormat = explode(".", $file);
                $file_format = end( $tmpArFileFormat );
                if ( $file_format == "tpl" )
                $self->files_list[$file] = $item . "_" . $file;
            }
        
        $dir->close();
        }
        return $self->files_list;
    }

    function getDetails($name, &$PLUGIN_English_NAME, &$PLUGIN_FARSI_NAME, &$PLUGIN_DEV){
        if( @file_exists( PLUGINS_DIR . '/' . $name . '/info.php' ) ) {
            include(PLUGINS_DIR . '/' . $name . '/info.php');
            if (!isset($PLUGIN_DEV))
                $PLUGIN_DEV = "ناشناس";                            
            return true;
        }else{
            return false;
        }
    }
    
    function deletePlugin($PluginName){
        global $db;
        include_once(PLUGINS_DIR."/{$PluginName}/action.php");
        if ( $uninstall_mysql ){
            foreach($uninstall_mysql as $table) {
                $db->query($table);
            }
        }if ( $unedit_files ){
            foreach ($unedit_files as $key => $value)
            {
            	$important_files[] = $unedit_files[$key]['open'];
            }
            
            if (!$chmod_errors and !$file_errors)
            {
            	foreach ($unedit_files as $file)
            	{
            		$file_edit = file_get_contents($file['open']);
            		
            		if (@!eregi($file['key'], $file_edit))
            		{
            $new_file = str_replace($file['find'], $file['before'].(($file['replace']!="")?$file['replace']:$file['find'])."\n".$file['add'], $file_edit);
            
            $fd = @fopen($file['open'], "w+");
            fwrite($fd, $new_file);
            fclose($fd);
            chmod($file['open'], 0644);
            		}
            	}
            	
            	$next_act = 6;
            }
            }
            if ( $uninstall_commands ){
                foreach ($uninstall_commands as $u_command) {
                    include_once $u_command;
                }
            }
        $flag = true;
        $flag = $this->deleteDir("plugins/" . $PluginName);
        if ( $flag )
            return true;
        else
            return false;
    }
    
    function install_plugin($zip_file) {
        @$archive = new PclZip(ROOT_DIR . "/" . $zip_file);
        @chmod(ROOT_DIR . "/" . $zip_file, 0777);
        $lst = $archive->listContent();
        $pluginNames = array();
        $existDirs = array();
        $pluginList = $this->PluginList();
        $isPlugin = 0;
        foreach ($lst as $arr) {
            $plugin = explode("/", $arr['filename']);
            if (array_search($plugin[0], $pluginNames) === false) {
                $pluginNames[] = $plugin[0];
                if (array_search($plugin[0], $pluginList) !== false) {
                    $existDirs[] = $plugin[0];
                }
            }
            if ($arr['filename'] == $plugin[0] . "/info.php" || $arr['filename'] == $plugin[0] . "/action.php")
                $isPlugin++;
        }
        
        if ($isPlugin != 2)
            $message = "این فایل پلاگین نمی باشد، لطفاً یک پلاگین معتبر را برای نصب انتخاب کنید .";
        elseif (!count($existDirs)) {
            $archive->extract(PCLZIP_OPT_PATH, 'plugins');
            $status = $archive->errorCode();
            
            if ( $status )
                $message = "خطایی در نصب پلاگین رخ داده است. شماره ی خطا: {$status}";
            
            if (count($pluginNames) == 1) {
                $message = "پلاگین <strong>{$pluginNames[0]}</strong> با موفقیت نصب شد .";
            }elseif(count($pluginNames) > 1){
                $uapluginNames = implode("، ", $pluginNames);
                $message = "پلاگین های <strong>{$uapluginNames}</strong> با موفقیت نصب شدند .";
            }else{
                $message = "خطایی در نصب پلاگین رخ داده است.";
            }
            
        }else{
            if (count($existDirs) == 1 && count($pluginNames) == 1) {
                $message = "شما پلاگین <strong>{$existDirs[0]}</strong> را قبلاً بر روی سیستم نصب کرده اید.<br />برای نصب این پلاگین می بایست ابتدا پلاگین قبلی را از روی سیستم حذف کنید ...";
            }elseif(count($existDirs) == 1){
                $uaExistDirs = implode("، ", $existDirs);
                $message = "شما پلاگین <strong>{$uaExistDirs}</strong> را قبلاً بر روی سیستم نصب کرده اید.<br />برای نصب این مجموعه پلاگین می بایست ابتدا پلاگین ذکر شده را از روی سیستم حذف کنید ...";
            }elseif(count($existDirs) > 1){
                $uaExistDirs = implode("، ", $existDirs);
                $message = "شما پلاگین های <strong>{$uaExistDirs}</strong> را قبلاً بر روی سیستم نصب کرده اید.<br />برای نصب این مجموعه پلاگین می بایست ابتدا پلاگین های ذکر شده را از روی سیستم حذف کنید ...";
            }
            
        }
        
        @unlink(ROOT_DIR . "/" . $zip_file);
        return $message;
    }
    
    public static function checkPlugin($key){
        $str = file_get_contents("http://www.tdatalife.com/store/chk.php?key=" . $key);
    	if(strlen($str)>0){
    		preg_match("/(.*)/",$str,$data);
    		return $data[1];
    	}
    }
    
    function deleteDir($directory) {
        if (is_dir($directory))
            $dir = opendir($directory);
        else
            return false;
      
        while($file = readdir($dir)) {
      
            if ($file != "." && $file != ".."){
            //chmod($directory.$file, 0777);
    
                if (!is_dir($directory."/".$file))
                    unlink($directory."/".$file);
                else
                    $this->deleteDir($directory.'/'.$file);   
            }
        }
        closedir($dir);
        rmdir($directory);
        return true;
    }

}

?>