<?php
/*
=====================================================
 DataLife Engine - by TdataLife Team
-----------------------------------------------------
 http://www.Tdatalife.com/
-----------------------------------------------------
 Copyright (c) 2004,2013 TdataLife Team
=====================================================
*/

@ob_start();
@ob_implicit_flush(0);

if( !defined( 'E_DEPRECATED' ) ) {

	@error_reporting ( E_ALL ^ E_WARNING ^ E_NOTICE );
	@ini_set ( 'error_reporting', E_ALL ^ E_WARNING ^ E_NOTICE );

} else {

	@error_reporting ( E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE );
	@ini_set ( 'error_reporting', E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE );

}

@ini_set ( 'display_errors', true );
@ini_set ( 'html_errors', false );

define ( 'DATALIFEENGINE', true );
define ( 'ROOT_DIR', dirname ( __FILE__ ) );
define ( 'ENGINE_DIR', ROOT_DIR . '/engine' );
define ( 'PLUGINS_DIR', ROOT_DIR . '/plugins' ); 

//#################
$check_referer = true;
//#################

require_once (ENGINE_DIR . '/inc/include/init.php');

if ($is_loged_in == FALSE) {

	$m_auth = $config['auth_metod'] ? "loginbox2" : "loginbox1";

	if( ! $handle = opendir( "./language" ) ) {
		die( "Folder /language/ not found" );
	}

	while ( false !== ($file = readdir( $handle )) ) {
		if( is_dir( ROOT_DIR . "/language/$file" ) and ($file != "." and $file != "..") ) {
			$sys_con_langs_arr[$file] = $file;
		}
	}
	closedir( $handle );

	function makeDropDown($options, $name, $selected) {
		$output = "<select name=\"$name\">\r\n";
		foreach ( $options as $value => $description ) {
			$output .= "<option value=\"$value\"";
			if( $selected == $value ) {
				$output .= " selected ";
			}
			$output .= ">$description</option>\n";
		}
		$output .= "</select>";
		return $output;
	}

	$select_language = makeDropDown( $sys_con_langs_arr, "selected_language", $selected_language );

	$skin_login = str_replace("{mauth}", $m_auth, $skin_login);
	$skin_login = str_replace("{select}", $select_language, $skin_login);
	$skin_login = str_replace("{result}", $result, $skin_login);

	echo $skin_login;
	
	exit ();

} elseif ($is_loged_in == TRUE) {

    function checkPlugin($name){
        global $db;
        $row = $db->super_query( "SELECT `status` FROM `" . PREFIX . "_addons` where `name`='{$name}'" );
        if ( count($row) > 0 && $row['status'] )
            return true;
        else
            return false;
    }

	if ( !$mod ) {

		include (ENGINE_DIR . '/inc/main.php');

	} elseif ( @file_exists( ENGINE_DIR . '/inc/' . $mod . '.php' ) ) {
		
		include (ENGINE_DIR . '/inc/' . $mod . '.php');

    } elseif ( @file_exists( PLUGINS_DIR . '/' . $mod . '/inc/' . $mod . '.php' ) && empty($zone) && checkPlugin($mod) ) {
        include (PLUGINS_DIR . '/' . $mod . '/inc/' . $mod . '.php');
        
    } elseif ( @file_exists( PLUGINS_DIR . '/' . $mod . '/inc/' . $zone . '.php' ) && checkPlugin($mod) ) {
        include (PLUGINS_DIR . '/' . $mod . '/inc/' . $zone . '.php');

	} else {
		$db->close ();
		msg ( "error", $lang['index_denied'], $lang['mod_not_found'] );
	}
}

$db->close ();

GzipOut ();
?>