<?php
/*
=====================================================
 DataLife Engine - by TdataLife Team
-----------------------------------------------------
 http://www.Tdatalife.com/
-----------------------------------------------------
 Copyright (c) 2004,2013 TdataLife Team
=====================================================
*/

if( ! defined( 'DATALIFEENGINE' ) ) {
	define( 'DATALIFEENGINE', true );
}
if( ! defined( 'ROOT_DIR' ) ) {
	define( 'ROOT_DIR', substr( dirname( __FILE__ ), 0, - 11 ) );
}

if( ! defined( 'ENGINE_DIR' ) ) {
	define( 'ENGINE_DIR', ROOT_DIR . '/engine' );
}

if( ! class_exists( 'TDLE_API' ) )
{
	class TDLE_API
	{
	   var $db = false;
       var $dle_config = array();
       
     	/**
     	 * TDLE_API::tdata()
     	 * 
     	 * @param mixed $key: Var key
     	 * @param string $new_value: New value for this key
     	 * @param string $file_name: Name of file to write
     	 * @return void
     	 */
     	function tdata($key, $new_value = '', $file_name = 'data.php')
        {
            @include(PLUGINS_DIR . $file_name);
            $find[] = "'\r'";
            $replace[] = "";
            $find[] = "'\n'";
            $replace[] = "";
            if (is_array($key)) {
                foreach ($key as $ckey => $cvalue) {
                    if ($filedata[$ckey]) {
                        $filedata[$ckey] = $cvalue;
                    }
                }
            } else {
                $filedata[$key] = $new_value;
            }
            $handle = @fopen(PLUGINS_DIR . $file_name, 'w');
            fwrite($handle, "<?PHP \n\$filedata = array (\n\n");
            foreach ($filedata as $name => $value) {
                if ($name != "offline_reason") {
                    $value = trim(stripslashes($value));
                    $value = htmlspecialchars($value);
                    $value = preg_replace($find, $replace, $value);
                    $name = trim(stripslashes($name));
                    $name = htmlspecialchars($name, ENT_QUOTES);
                    $name = preg_replace($find, $replace, $name);
                }
                $value = str_replace("$", "&#036;", $value);
                $value = str_replace("{", "&#123;", $value);
                $value = str_replace("}", "&#125;", $value);
                $name = str_replace("$", "&#036;", $name);
                $name = str_replace("{", "&#123;", $name);
                $name = str_replace("}", "&#125;", $name);
                fwrite($handle, "'{$name}' => \"{$value}\",\n");
            }
            fwrite($handle, ");\n\n?>");
            fclose($handle);
        }
        
        /**
         * TDLE_API::OpenTdata()
         * 
         * @param mixed $file_name: File path to open
         * @return data array from file
         */
        function OpenTdata($file_name){
            @include_once($file_name);
            return $filedata;
        }
	}
}

	$TDLE_API = new TDLE_API ();
	if( ! $config['version_id'] ) include_once (ENGINE_DIR . '/data/config.php');
	$TDLE_API->dle_config = $config;
	if( ! isset( $db ) ) {
		include_once (ENGINE_DIR . '/classes/mysql.php');
		include_once (ENGINE_DIR . '/data/dbconfig.php');
	}
	$TDLE_API->db = $db;
?>