var totaluploadedfiles = 0;

function fileQueued(a) {
  try {
    var d = new FileProgress(a, this.customSettings.progressTarget);
    d.setStatus("\u0412 \u043e\u0447\u0435\u0440\u0435\u0434\u0438 ...");
    d.toggleCancel(true, this)
  }catch(b) {
    this.debug(b)
  }
}
function fileQueueError(a, d, b) {
  try {
    if(d === SWFUpload.QUEUE_ERROR.QUEUE_LIMIT_EXCEEDED) {
      alert("File Queue Limit Excedded" + (b === 0 ? "The file queue has exceeded the limit setting." : "We have set the bulk upload limit " + (b > 1 ? "You can upload no more than " + b + " file at the time." : 
      "File Queue Limit Excedded.")))
    }else {
      var c = new FileProgress(a, this.customSettings.progressTarget);
      c.setError();
      c.toggleCancel(false);
      switch(d) {
        case SWFUpload.QUEUE_ERROR.FILE_EXCEEDS_SIZE_LIMIT:
          c.setStatus("File size is too big.");
          this.debug("Error Code: File too big, File name: " + a.name + ", File size: " + a.size + ", Message: " + b);
          break;
        case SWFUpload.QUEUE_ERROR.ZERO_BYTE_FILE:
          c.setStatus("Zero byte file size.");
          this.debug("Error Code: Zero byte file, File name: " + a.name + ", File size: " + a.size + ", Message: " + b);
          break;
        case SWFUpload.QUEUE_ERROR.INVALID_FILETYPE:
          c.setStatus("Invalid File Type.");
          this.debug("Error Code: Invalid File Type, File name: " + a.name + ", File size: " + a.size + ", Message: " + b);
          break;
        default:
          a !== null && c.setStatus("Upload Failed");
          this.debug("Error Code: " + d + ", File name: " + a.name + ", File size: " + a.size + ", Message: " + b);
          break
      }
    }
  }catch(e) {
    this.debug(e)
  }
}
function fileDialogComplete(a, d) {
  try {
    if(a > 0) {
      document.getElementById(this.customSettings.cancelButtonId).disabled = false
    }
    elements = document.getElementById("form").elements;
    for(i = 0;i < elements.length;i++) {
      if(name = elements[i].name) {
        value = "";
        switch(elements[i].type) {
          case "select":
            value = elements[i].options[elements[i].selectedIndex].value;
            break;
          case "radio":
          ;
          case "checkbox":
            value = elements[i].checked ? 1 : 0;
            break;
          default:
            value = elements[i].value;
            break
        }
        this.addPostParam(name, value)
      }
    }
    this.startUpload()
  }catch(b) {
    this.debug(b)
  }
}
function uploadStart(a) {
  try {
    var d = new FileProgress(a, this.customSettings.progressTarget);
    d.setStatus("Uploading...");
    d.toggleCancel(true, this)
  }catch(b) {
  }
  return true
}
function uploadProgress(a, d, b) {
  try {
    var c = Math.ceil(d / b * 100), e = new FileProgress(a, this.customSettings.progressTarget);
    e.setProgress(c);
    e.setStatus("Uploading...")
  }catch(f) {
    this.debug(f)
  }
}
function uploadSuccess(a, d) {
  try {
    var b = new FileProgress(a, this.customSettings.progressTarget);
    b.setComplete();
	var reports = eval( '('+d+')' );

	if ( reports.error ) {
		b.setError();
		b.setStatus(reports.error);
	} else {

    	b.setStatus("Upload Completed.");

		if ( reports.success ) {
			totaluploadedfiles ++;
			var returnbox = reports.returnbox;

			returnbox = returnbox.replace(/&lt;/g, "<");
			returnbox = returnbox.replace(/&gt;/g, ">");
			returnbox = returnbox.replace(/&amp;/g, "&");

			$('#cont1').append( returnbox );

		}

	}

    b.toggleCancel(false);
  }catch(c) {
    this.debug(c)
  }
}
function uploadError(a, d, b) {
  try {
    var c = new FileProgress(a, this.customSettings.progressTarget);
    c.setError();
    c.toggleCancel(false);
    switch(d) {
      case SWFUpload.UPLOAD_ERROR.HTTP_ERROR:
        c.setStatus("Error: " + b);
        this.debug("Error Code: HTTP Error, File name: " + a.name + ", Message: " + b);
        break;
      case SWFUpload.UPLOAD_ERROR.UPLOAD_FAILED:
        c.setStatus("Upload Failed.");
        this.debug("Error Code: Upload Failed, File name: " + a.name + ", File size: " + a.size + ", Message: " + b);
        break;
      case SWFUpload.UPLOAD_ERROR.IO_ERROR:
        c.setStatus("Server (IO) Error");
        this.debug("Error Code: IO Error, File name: " + a.name + ", Message: " + b);
        break;
      case SWFUpload.UPLOAD_ERROR.SECURITY_ERROR:
        c.setStatus("Security Error");
        this.debug("Error Code: Security Error, File name: " + a.name + ", Message: " + b);
        break;
      case SWFUpload.UPLOAD_ERROR.UPLOAD_LIMIT_EXCEEDED:
        c.setStatus("Upload Limit Exceeded.");
        this.debug("Error Code: Upload Limit Exceeded, File name: " + a.name + ", File size: " + a.size + ", Message: " + b);
        break;
      case SWFUpload.UPLOAD_ERROR.FILE_VALIDATION_FAILED:
        c.setStatus("File Validation Failed.");
        this.debug("Error Code: File Validation Failed, File name: " + a.name + ", File size: " + a.size + ", Message: " + b);
        break;
      case SWFUpload.UPLOAD_ERROR.FILE_CANCELLED:
        if(this.getStats().files_queued === 0) {
          document.getElementById(this.customSettings.cancelButtonId).disabled = true
        }
        c.setStatus("Cancelled");
        c.setCancelled();
        break;
      case SWFUpload.UPLOAD_ERROR.UPLOAD_STOPPED:
        c.setStatus("Stopped");
        break;
      default:
        c.setStatus("Upload Error: " + d);
        this.debug("Error Code: " + d + ", File name: " + a.name + ", File size: " + a.size + ", Message: " + b);
        break
    }
  }catch(e) {
    this.debug(e)
  }
}
function uploadComplete(a) {
  if(this.getStats().files_queued === 0) {
    document.getElementById(this.customSettings.cancelButtonId).disabled = true
  }
}
function queueComplete(a) {

	setTimeout("location.replace( window.location )",2E3);

	totaluploadedfiles = 0;
}
;