/*** Translation ***/
LanguageDirectory="en-US";

function getTxt(s)
  {
  switch(s)
    {
    case "Save":return "ذخیره";
    case "Preview":return "پیش نمایش";
    case "Full Screen":return "تمام صفحه";
    case "Search":return "جستجو";
    case "Check Spelling":return "بررسی املا";
    case "Text Formatting":return "قالب بندی متن";
    case "List Formatting":return "قالب بندی لیست";
    case "Paragraph Formatting":return "قالب بندی پاراگراف";
    case "Styles":return "استیل ها";
    case "Custom CSS":return "CSS سفارشی";
    case "Styles & Formatting":return "استیل و قالب بندی";
    case "Style Selection":return "انتخاب استیل";
    case "Paragraph":return "پاراگراف";
    case "Font Name":return "نام قلم";
    case "Font Size":return "اندازه ی قلم";
    case "Cut":return "برش";
    case "Copy":return "رونوشت";
    case "Paste":return "چسباندن";
    case "Undo":return "خنثی کردن";
    case "Redo":return "ازنو";
    case "Bold":return "درشت";
    case "Italic":return "خط مورب";
    case "Underline":return "زیر خط دار";
    case "Strikethrough":return "خورده";
    case "Superscript":return "بالانویس";
    case "Subscript":return "زیر نویس";
    case "Justify Left":return "تراز چپ";
    case "Justify Center":return "تراز وسط";
    case "Justify Right":return "تراز راست";
    case "Justify Full":return "تراز کامل";
    case "Numbering":return "عددی";
    case "Bullets":return "گلوله ای";
    case "Indent":return "دندانه دار کردن";
    case "Outdent":return "اصلی کردن";
    case "Left To Right":return "چپ به راست";
    case "Right To Left":return "راست به چپ";
    case "Foreground Color":return "رنگ پیش نما";
    case "Background Color":return "رنگ پس زمینه";
    case "Hyperlink":return "لینک";
    case "Bookmark":return "نشانه گذاری";
    case "Special Characters":return "کاراکتر های ویژه";
    case "Image":return "عکس";
    case "Flash":return "Flash";
    case "Media":return "مدیا";
    case "Content Block":return "بلاک محتوی";
    case "Internal Link":return "لینک داخلی";
    case "Internal Image":return "عکس داخلی";
    case "Object":return "شئ";
    case "Insert Table":return "درج جدول";
    case "Table Size":return "اندازه ی جدول";
    case "Edit Table":return "ویرایش جدول";
    case "Edit Cell":return "ویرایش سلول";
    case "Table":return "جدول";
    case "AutoTable":return "جدول با قالب بندی خودکار";
    case "Border & Shading":return "سایه و هاشیه";
    case "Show/Hide Guidelines":return "نمایش/مخفی Guidelines";
    case "Absolute":return "Absolute";
    case "Paste from Word":return "چسباندن از Word";
    case "Line":return "خط";
    case "Form Editor":return "ویرایشگر فرم";
    case "Form":return "فرم";
    case "Text Field":return "فیلد متن";
    case "List":return "فهرست";
    case "Checkbox":return "چک باکس";
    case "Radio Button":return "دکمه ی رادیویی";
    case "Hidden Field":return "فیلد مخفی";
    case "File Field":return "فیلد فایل";
    case "Button":return "کلید";
    case "Clean":return "پاک";//not used
    case "View/Edit Source":return "مشاهده / ویرایش متن";
    case "Tag Selector":return "تگ انتخاب";
    case "Clear All":return "پاک کردن همه";
    case "Tags":return "تگ ها";

    case "Heading 1":return "عنوان گذاری 1";
    case "Heading 2":return "عنوان گذاری 2";
    case "Heading 3":return "عنوان گذاری 3";
    case "Heading 4":return "عنوان گذاری 4";
    case "Heading 5":return "عنوان گذاری 5";
    case "Heading 6":return "عنوان گذاری 6";
    case "Preformatted":return "تنظیم نشده";
    case "Normal (P)":return "عادی (P)";
    case "Normal (DIV)":return "عادی (DIV)";

    case "Size 1":return "اندازه ی 1";
    case "Size 2":return "اندازه ی 2";
    case "Size 3":return "اندازه ی 3";
    case "Size 4":return "اندازه ی 4";
    case "Size 5":return "اندازه ی 5";
    case "Size 6":return "اندازه ی 6";
    case "Size 7":return "اندازه ی 7";

    case "Are you sure you wish to delete all contents?":
      return "آیا واقعاً می خواهید کل محتوا را پاک کنید ؟";
    case "Remove Tag":return "حذف تگ";
    case "Custom Colors":return "رنگ های پیشرفته";
    case "More Colors...":return "رنگ های بیشتر...";
    case "Box Formatting":return "قالب بندی جعبه";
    case "Advanced Table Insert":return "درج جدول پیشرفته";
    case "Edit Table/Cell":return "ویرایش جدول / سلول";
    case "Print":return "چاپ";
    case "Paste Text":return "چسباندن متن";
    case "CSS Builder":return "CSS ساز";
    case "Remove Formatting":return "حذف قالب بندی";
    case "Table Dimension Text": return "جدول";
    case "Table Advance Link": return "پیشرفته";

    case "Fonts": return "قلم ها";    
    case "Text": return "متن";
    case "Link": return "لینک";
    case "YoutubeVideo": return "ویدئو Youtube";
    case "Search & Replace": return "جستجو و جایگزین";
    case "HTML Editor": return "ویرایشگر HTML";
    case "Emoticons": return "شکلک ها";
    case "PasteWarning": return "Please paste using the keyborad (CTRL-V)."; /*Your browser security settings don't permit this operation.*/

    default:return "";
    }
  }