<?php

/**
 * -------------------------------------
 * @Author      Reza Moghaddam
 * @URL         moghaddam24.ir
 * @Email       r324.moghaddam@gmail.com
 * @Tel         09156990565
 * -------------------------------------
 */

if (!defined('DATALIFEENGINE'))
{
    die("Hacking attempt!");
}

if ($member_id['user_group'] != 1) {
    msg("info", $lang['tdata_error'], $lang['tdata_prem_error'], "{$PHP_SELF}?mod=addons");
}

include_once ENGINE_DIR . '/classes/r324.php';
include_once ENGINE_DIR.'/classes/pclzip.class.php';
include_once ENGINE_DIR . '/api/api.class.php';

function ThemeList()
{
    $dir_list = array();

    $handle = opendir('./templates');

    while (false !== ($file = readdir($handle)))
    {
        if (is_dir("./templates/$file") and ($file != "." and $file != ".."))
        {
            $dir_list[] = $file;
        }
    }
    closedir($handle);

    return $dir_list;
}

function deleteDir($directory)
{
    if (is_dir($directory))
        $dir = opendir($directory);
    else
        return false;

    while ($file = readdir($dir))
    {

        if ($file != "." && $file != "..")
        {
            //chmod($directory.$file, 0777);

            if (!is_dir($directory . "/" . $file))
                unlink($directory . "/" . $file);
            else
                deleteDir($directory . '/' . $file);
        }
    }
    closedir($dir);
    rmdir($directory);
    return true;
}

if ( $action == "enable" ){
    $name = stripslashes($_GET['name']);
    $dle_api->edit_config('skin', $name);
    echo "<script type=\"text/javascript\">
    document.location=\"{$PHP_SELF}?mod=themes\";
</script>";
        
}else if ( $action == "disable" ){
    $name = stripslashes($_GET['name']);
    deleteDir("templates/" . $name);
    echo "<script type=\"text/javascript\">
    document.location=\"{$PHP_SELF}?mod=themes\";
</script>";

}else if ( $action == "upload" ){
    $moghaddam->overwrite = true;
    $moghaddam->dir = "templates/";
    $link = $moghaddam->upload('theme');
    @$archive = new PclZip($link);
    $archive->extract(PCLZIP_OPT_PATH, 'templates');
    unlink($link);
    $status = $archive->errorCode();
    echo "<script type=\"text/javascript\">
    document.location=\"{$PHP_SELF}?mod=themes\";
</script>";
        
}else{

$templates = "";
$themes_list = ThemeList();
$intCurrentThemeIndex = array_search($config['skin'], $themes_list);
unset($themes_list[$intCurrentThemeIndex]);
foreach ($themes_list as $theme) {
    if ( file_exists(ROOT_DIR . "/templates/{$theme}/images/snapshot.jpg") )
        $picture = "<div style=\"text-align:center;\"><img src=\"{$config['http_home_url']}/templates/{$theme}/images/snapshot.jpg\" style=\"width:320px; height:219px; border: solid 1px #B6B6B6;\" /></div>";
    else
        $picture = "<div style=\"text-align:center;\"><img src=\"{$config['http_home_url']}/engine/skins/images/snapshot.jpg\" style=\"width:320px; height:219px;\" /></div>";
        
    $templates .= <<<HTML
    <div class="theme_box">
    <form method="post" action="{$PHP_SELF}?mod=themes&action=save">
        <div style="height:5px;"></div>
        {$picture}
        <hr />
        <div style="text-align:center;"><strong>{$theme}</strong>
        <hr style="border:dashed 1px #B6B6B6;" />
            <input type="hidden" name="name" value="{$theme}" />
            <input type="button" class="btn btn-success" onclick="confirmEnable('{$theme}');" value="&nbsp;{$lang['tdata_thm_apply']}&nbsp;" />&nbsp;<input type="button" class="btn btn-danger" onclick="confirmDisable('{$theme}');" value="&nbsp;{$lang['tdata_thm_del']}&nbsp;" />
        </div>
    </div>
    </form>
HTML;
}
$page = <<< HTML
<style type="text/css">
.theme_box{
    width:330px; float: right; height:300px; border: solid 1px #B6B6B6; margin-left: 10px;
}
</style>
<script type="text/javascript">
function confirmEnable(name){
	DLEconfirm("{$lang['tdata_thm_applymsg']}" ,"{$lang['tdata_warn']}",function(){
		document.location="{$PHP_SELF}?mod=themes&action=enable&name=" + name;
	});
}
function confirmDisable(name){
	DLEconfirm("{$lang['tdata_thm_delmsg']}" ,"{$lang['tdata_warn']}",function(){
		document.location="{$PHP_SELF}?mod=themes&action=disable&name=" + name;
	});
}
</script>

<table style="width:100%;">
<tr>
    <td style="width:100%;"><br />
    <form method="post" action="{$PHP_SELF}?mod=themes&action=upload" enctype="multipart/form-data">
        <table style="width:100%;">
            <tr>
                <td style="width: 130px;">{$lang['tdata_thm_default']}</td>
                <td><strong>{$config['skin']}</strong></td>
            </tr>
            <tr><td colspan="2"><div style="height:2px;"></div></td></tr>
            <tr><td colspan="2" background="engine/skins/images/mline.gif" height="1"></td></tr>
            <tr><td colspan="2"><div style="height:2px;"></div></td></tr>
            <tr>
                <td style="width: 130px;">{$lang['tdata_thm_upnew']}</td>
                <td><input type="file" class="edit" name="theme" /></td>
            </tr>
            <tr>
                <td style="width: 130px;"></td>
                <td><input name="save" type="submit" class="btn" value="&nbsp;{$lang['tdata_thm_upnewbtn']}&nbsp;" /></td>
            </tr>
        </table><br />
    </form>
    </td>
</tr>
<tr><td colspan="3"><div class="hr_line"></div></td></tr>
<tr>
    <td style="width:100%;">
        <div style="width:98%;">
            {$templates}
        </div>
    </td>
</tr>
</table>
HTML;

$moghaddam->blank("themes", $lang['tdata_thm'], $page);
}
?>  