<?php
/*
=====================================================
 DataLife Engine - by TdataLife Team
-----------------------------------------------------
 http://www.Tdatalife.com/
-----------------------------------------------------
 Copyright (c) 2004,2013 TdataLife Team
=====================================================
*/

if( ! defined( 'DATALIFEENGINE' ) ) {
	die( "Hacking attempt!" );
}

$is_change = false;

if ($config['allow_cache'] != "yes") { $config['allow_cache'] = "yes"; $is_change = true;}

#  
function cal($cal_month, $cal_year, $events) {
	global $f, $r, $year, $month, $config, $lang, $langdateshortweekdays, $PHP_SELF;
	$next = true;
	
	if( intval( $cal_year . $cal_month ) >= jdate( 'Ym' ) AND !$config['news_future'] ) $next = false;

	$cur_date=jdate( 'Ymj', time() + ($config['date_adjust'] * 60) );
	$cal_date = $cal_year.$cal_month;

	$cal_month = intval( $cal_month );
	$cal_year = intval( $cal_year );
	
	if( $cal_month < 0 ) $cal_month = 1;
	if( $cal_year < 0 ) $cal_year = 2008;
	
	$first_of_month = jmktime( 0, 0, 0, $cal_month, 1, $cal_year );
	$maxdays = jdate( 't', $first_of_month ) + 1; // 28-31
	$prev_of_month = jmktime( 0, 0, 0, ($cal_month - 1), 1, $cal_year );
	$next_of_month = jmktime( 0, 0, 0, ($cal_month + 1), 1, $cal_year );
	$cal_day = 1;
	$weekday = jdate( 'w', $first_of_month ); // 0-6

	if( $config['allow_alt_url'] == "yes" ) {
		
		$date_link['prev'] = '<a class="monthlink" onclick="doCalendar(' . jdate( "'m','Y'", $prev_of_month ) . ',\'right\'); return false;" href="' . $config['http_home_url'] . jdate( 'Y/m/', $prev_of_month ) . '" title="' . $lang['prev_moth'] . '">&laquo;</a>&nbsp;&nbsp;&nbsp;&nbsp;';
		$date_link['next'] = '&nbsp;&nbsp;&nbsp;&nbsp;<a class="monthlink" onclick="doCalendar(' . jdate( "'m','Y'", $next_of_month ) . ',\'left\'); return false;" href="' . $config['http_home_url'] . jdate( 'Y/m/', $next_of_month ) . '" title="' . $lang['next_moth'] . '">&raquo;</a>';
	
	} else {
		
		$date_link['prev'] = '<a class="monthlink" onclick="doCalendar(' . jdate( "'m','Y'", $prev_of_month ) . ',\'right\'); return false;" href="' . $PHP_SELF . '?year=' . jdate( "Y", $prev_of_month ) . '&amp;month=' . jdate( "m", $prev_of_month ) . '" title="' . $lang['prev_moth'] . '">&laquo;</a>&nbsp;&nbsp;&nbsp;&nbsp;';
		$date_link['next'] = '&nbsp;&nbsp;&nbsp;&nbsp;<a class="monthlink" onclick="doCalendar(' . jdate( "'m','Y'", $next_of_month ) . ',\'left\'); return false;" href="' . $PHP_SELF . '?year=' . jdate( "Y", $next_of_month ) . '&amp;month=' . jdate( "m", $next_of_month ) . '" title="' . $lang['next_moth'] . '">&raquo;</a>';
	
	}
	
	if( ! $next ) $date_link['next'] = "&nbsp;&nbsp;&nbsp;&nbsp;&raquo;";
	
	$buffer = '<div id="calendar-layer"><table id="calendar" cellpadding="3" class="calendar"><tr><th colspan="7" class="monthselect">' . $date_link['prev'] . langdate( 'F', $first_of_month ) . ' ' . $cal_year . $date_link['next'] . '</th></tr><tr>';
	
	$buffer = str_replace( $f, $r, $buffer );
	
	# Ayyame hafte
	for($it = 0; $it < 6; $it ++)
		$buffer .= '<th class="workday">' . $langdateshortweekdays[$it] . '</th>';
		
	#  :    
	$buffer .= '<th class="weekday">' . $langdateshortweekdays[6] . '</th>';
	
	$buffer .= '</tr><tr>';
	
	if( $weekday > 0 ) {
		$buffer .= '<td colspan="' . $weekday . '">&nbsp;</td>';
	}
    
	while ( $maxdays > $cal_day ) {

		$cal_pos = $cal_date.$cal_day;
        
		if( $weekday == 7 ) {
			$buffer .= '</tr><tr>';
			$weekday = 0;
		}
		
		#     
		if( isset( $events[$cal_day] ) ) {
			$date['title'] = langdate( 'd F Y', $events[$cal_day] );
			
			#    .
			if( $weekday == '6' ) {
								
				if( $config['allow_alt_url'] == "yes" ) $buffer .= '<td '.(($cal_pos==$cur_date)?' class="day-active day-current" ':' class="day-active" ').'><a class="day-active" href="' . $config['http_home_url'] . '' . jdate( "Y/m/d", $events[$cal_day] ) . '/" title="' . $lang['cal_post'] . ' ' . $date['title'] . '">' . $cal_day . '</a></td>';
				else $buffer .= '<td '.(($cal_pos==$cur_date)?' class="day-active day-current" ':' class="day-active" ').'><a class="day-active" href="' . $PHP_SELF . '?year=' . jdate( "Y", $events[$cal_day] ) . '&amp;month=' . jdate( "m", $events[$cal_day] ) . '&day=' . jdate( "d", $events[$cal_day] ) . '" title="' . $lang['cal_post'] . ' ' . $date['title'] . '">' . $cal_day . '</a></td>';
			
			} 

			#  .
			else {
				
				if( $config['allow_alt_url'] == "yes" ) $buffer .= '<td '.(($cal_pos==$cur_date)?' class="day-active-v day-current" ':' class="day-active-v" ').'><a class="day-active-v" href="' . $config['http_home_url'] . '' . jdate( "Y/m/d", $events[$cal_day] ) . '/" title="' . $lang['cal_post'] . ' ' . $date['title'] . '">' . $cal_day . '</a></td>';
				else $buffer .= '<td '.(($cal_pos==$cur_date)?' class="day-active-v day-current" ':' class="day-active-v" ').'><a class="day-active-v" href="' . $PHP_SELF . '?year=' . jdate( "Y", $events[$cal_day] ) . '&amp;month=' . jdate( "m", $events[$cal_day] ) . '&day=' . jdate( "d", $events[$cal_day] ) . '" title="' . $lang['cal_post'] . ' ' . $date['title'] . '">' . $cal_day . '</a></td>';
			
			}
		} 

		#     .
		else {
			
			# Rooz ha
			if( $weekday == "6" ) {
				$buffer .= '<td '.(($cal_pos==$cur_date)?' class="weekday day-current" ':' class="weekday" ').'>' . $cal_day . '</td>';
			} 

			# ,   
			else {
				$buffer .= '<td '.(($cal_pos==$cur_date)?' class="day day-current" ':' class="day" ').'>' . $cal_day . '</td>';
			}
		}
		
		$cal_day ++;
		$weekday ++;
	}
	
	if( $weekday != 7 ) {
		$buffer .= '<td colspan="' . (7 - $weekday) . '">&nbsp;</td>';
	}
	
	return $buffer . '</tr></table></div>';
}

# 
if( $config['allow_calendar'] == "yes" ) {
	
	$events = array ();
	
	$thisdate = date( "Y-m-d H:i:s", $_TIME );
	if( $config['no_date'] AND !$config['news_future'] ) $where_date = " AND date < '" . $thisdate . "'";
	else $where_date = "";
	
    $this_jmonth = jdate( 'm', $_TIME );
	$this_jyear = jdate( 'Y', $_TIME );
            
	$this_month = date( 'm', $_TIME );
	$this_year = date( 'Y', $_TIME );
    
    $this_date1 = date( 'Y-m-d', jmktime(0,0,0,($this_jmonth), 1, $this_jyear) );
    $this_date2 = date( 'Y-m-d', jmktime(0,0,0,($this_jmonth+1), 1, $this_jyear) );
        
	$sql = "";
	
	if( $year != '' and $month != '' ) $cache_id = $config['skin'] . $month . $year;
	else $cache_id = $config['skin'] . $this_month . $this_year;
	
	$tpl->result['calendar'] = dle_cache( "calendar", $cache_id );
	
	if( ! $tpl->result['calendar'] ) {
		$sql = "SELECT date FROM " . PREFIX . "_post WHERE date >= '{$this_date1}' AND date < '{$this_date2}' AND approve=1" . $where_date;
		if( $sql != "" ) {
			
			$db->query( $sql );
			
			while ( $row = $db->get_row() ) {
				$ts = strtotime( $row['date'] );
                $thisjday = jdate('d', $ts);
				$events[$thisjday] = $ts;
			}
			
			$db->free();
		}
		
		$tpl->result['calendar'] = cal( $this_jmonth, $this_jyear, $events );
        //echo($sql);
		create_cache( "calendar", $tpl->result['calendar'], $cache_id );
	}

}

#  
if( $config['allow_archives'] == "yes" ) {
	
	$tpl->result['archive'] = dle_cache( "archives", $config['skin'] );
	
	if( ! $tpl->result['archive'] ) {
  
		$added_time = time() + ($config['date_adjust'] * 60);
		$db->query("SELECT MIN(date), date FROM " . PREFIX . "_post GROUP BY date");
		$row = $db->get_row();
		$firstposty = jdate("Y", strtotime($row['date']) + $added_time);
		$firstpostm = jdate("m", strtotime($row['date']) + $added_time);
		
		$jal_month = jdate("m", $_TIME)+1;
		$jal_year = jdate("Y", $_TIME);
		if ($jal_month > 12) {
			$jal_month = 1;
			$jal_year++;
		}  
		
		$tpl->load_template("archives.tpl");
		
		while( jmktime( 0, 0, 0, $jal_month, 1, $jal_year ) >= -abs( jmktime( 0, 0, 0, $firstpostm, 1, $firstposty ) ) ){
			$jal_nextmonth = $jal_month - 1;
			$jal_nextyear = $jal_year;
			if ($jal_nextmonth < 1) {
				$jal_nextmonth = 12;
				$jal_nextyear--;
			}
					
			$thistime = jmktime(0,0,0,$jal_nextmonth,1,$jal_nextyear);
			$thisdate = date("Y-m-d H:i:s", $thistime);
            $nextdate = date("Y-m-d H:i:s", jmktime(0,0,0,$jal_month,1,$jal_year));
		   
			$db->query("SELECT id FROM " . PREFIX . "_post WHERE approve = '1' AND date >= '$thisdate' AND date < '$nextdate'");
			$count = $db->num_rows();
			
			if ($count > 0) {
				$arch_title['fa'] = jdate("F", $thistime);
				$arch_url[0] = jdate("m", $thistime);
				$arch_url[1] = jdate("Y", $thistime);
                if( $config['allow_alt_url'] == "yes" ) $news_archive[] = '<a class="archives" href="' . $config['http_home_url'] . "$arch_url[1]/$arch_url[0]" . '"><b>' . $arch_title['fa'] . ' (' . $count . ')</b></a>';
                else $news_archive[] = "<a class=\"archives\" href=\"$PHP_SELF?year=$arch_url[1]&amp;month=$arch_url[0]\"><b>" . $arch_title['fa'] . " (" . $count . ")</b></a>";
			}
			
			$jal_month = $jal_nextmonth;
			$jal_year = $jal_nextyear;	
			
		}
		
		$db->free();
		
		$i = count( $news_archive );
		
		if( $i > 6 ) {
			$news_archive[6] = "<div id=\"dle_news_archive\" style=\"display:none;\">" . $news_archive[6];
			$news_archive[] = "</div><div id=\"dle_news_archive_link\" ><br /><a class=\"archives\" onclick=\"$('#dle_news_archive').toggle('blind',{},700); return false;\" href=\"#\">" . $lang['show_archive'] . "</a></div>";
		}
		
		if( $i ) $tpl->result['archive'] = implode( "<br />", $news_archive );
		else $tpl->result['archive'] = "";
		
		create_cache( "archives", $tpl->result['archive'], $config['skin'] );
	}

}

if ($is_change) $config['allow_cache'] = false;

?>